_ = require 'lodash'
url = require 'url'
{EventEmitter} = require 'events'

class MeshbluSocketIO extends EventEmitter
  constructor: (@options, dependencies={}) ->
    @SocketIOClient = dependencies.SocketIOClient ? require 'socket.io-client'

  connect: (callback=->) =>
    options = _.defaults {}, @options.socketIOOptions, path: '/socket.io/v2'
    @socketIOClient = new @SocketIOClient @_buildUri(), options

    @socketIOClient.on 'connect', =>
      @identity uuid: @options.uuid, token: @options.token, callback

  identity: (data={}, callback=->) =>
    @socketIOClient.emit 'identity', data, (result) =>
      [error,data] = result
      return callback @_buildError(error) if error?
      callback null, data

  update: (query, params, callback) =>
    @updateDangerously query, {$set: params}, callback

  updateDangerously: (query, params, callback) =>
    @socketIOClient.emit 'update', [query, params], (result) =>
      [error, data] = result
      return callback @_buildError(error) if error?
      callback()

  _buildUri: =>
    uriOptions = _.defaults @options, {
      protocol: 'wss'
      slashes: true
    }

    url.format uriOptions

  _buildError: (errorResult) =>
    error = new Error errorResult.message
    error.status = errorResult.status
    error

module.exports = MeshbluSocketIO
